capture log close
drop _all
clear mata
clear matrix
log using land_thana.log, replace text
set matsize 800
use PKexp
#delimit;
gen byte indf = wchoice * (1 + (creditf <= 0));
gen byte indm = mchoice * (1 + (creditm <= 0));
gen thana=int(vill/10);
xi i.thana;
unab dummies: _Ithana*;
foreach var in `dummies' trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11  
             loghland educhead sexhead agehead maxeducf maxeducm  
             noadultm noadultf nospouse nontrgth round2 round3 {;
		gen ld`var' = loghland * `var' ;
} ;
quietly xi: cmp (lexptot =  trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11 
             loghland educhead sexhead agehead maxeducf maxeducm 
             noadultm noadultf nospouse nontrgth I.vill  
              round2 round3 ld*
	     creditfbrac creditfbrdb creditfgb creditmbrac creditmbrdb creditmgb)  
            (creditf   = trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11  
             loghland educhead sexhead agehead maxeducf maxeducm  
             noadultm nospouse _W*) 
            (creditm = trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11  
             loghland educhead sexhead agehead maxeducf maxeducm  
             noadultf nospouse _M*) 
            [pw=weight],ind(1 indf indm) tech(dfp) cluster(nh);
predict epsthana,res;
*drop ldnontrg* ldnontrg*;
gen zf = wchoice;
gen zm = mchoice;
xi i.thana;
unab dummies: _Ithana*;
foreach var in `dummies' trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11  
             loghland educhead sexhead agehead maxeducf maxeducm  
             noadultm noadultf nospouse { ;
		gen zf`var' = zf * `var' ;
		gen zm`var' = zm * `var' ;
   };
regress epsthana trlnd23 trlnd22 trlnd21 trlnd13 trlnd12 trlnd11  
             loghland educhead sexhead agehead maxeducf maxeducm  
             noadultm noadultf nospouse nontrgth 
              zf* zm* round2 round3 ld* [pw=weight], cluster(nh);
testparm zf* zm*;
scalar jdf=r(df)-2;
scalar list jdf;
display e(r2)*e(N);
scalar sg=e(r2)*e(N);
display 1-chi2(jdf,sg);
scalar hansen1= ( 1-chi2(jdf,(jdf+2)*r(F)) );
display (jdf+2)*r(F);
display hansen1;
log close;

